"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var charcodes = _interopRequireWildcard(require("charcodes"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _default(babel) {
  var t = babel.types;
  return {
    name: "ast-transform",
    // not required
    visitor: {
      ImportDeclaration: function ImportDeclaration(path, state) {
        if (path.node.source.value === "charcodes") {
          state.importedLocalName = path.node.specifiers[0].local.name; // We remove the import just in case

          path.remove();
        }
      },
      MemberExpression: function MemberExpression(path, state) {
        if (typeof state.importedLocalName !== "undefined" && path.node.object.name == state.importedLocalName) {
          var rightName = path.node.property.name;
          var charCodeValue = charcodes[rightName];

          if (typeof charCodeValue !== "function") {
            path.replaceWith(t.NumericLiteral(charCodeValue));
          } else {
            path.replaceWithSourceString(charCodeValue.toString()); // Replace the identifier by their value in the source

            path.traverse({
              Identifier: function Identifier(path) {
                var name = path.node.name;

                if (typeof charcodes[name] !== "undefined" && typeof charcodes[name] !== "function") {
                  path.replaceWith(t.NumericLiteral(charcodes[name]));
                }
              }
            });
          }
        }
      }
    }
  };
}